#!/usr/bin/perl

###############################################################################
#                                                                             #
#               Dimke's Multi Counter                                         #
#                                                                             #
#               All rights reserved. Copyright (C) 2004                       #
#               Dipl.-Ing. Markus Robert Keler                               #
#               Bad Schussenried, Germany                                     #
#                                                                             #
#               For latest updates see http://developer.dipl-ing-kessler.de   #
#                                                                             #
###############################################################################
#                                                                             #
#               Purpose:                                                      #
#                                                                             #
#               Place as many counters as you like on your web pages          #
#               and serve them all by only one counter program.               #
#               Define which counter names are allowed and store their        #
#               names and values in one file.                                 #
#               So this is a very economic and slim solution, which           #
#               gives you the maximum overview about your counters.           #
#                                                                             #
###############################################################################

$counter_file = '/full/path/to/cgi-bin/counters.txt';

### Do not change other parts of this script except the variable above ########

@values = split(/&/,$ENV{'QUERY_STRING'});
foreach $i (@values) {
   ($name, $value) = split(/=/,$i);
   if ( $name eq 'Counter_Name' ) {
      $counter_name = $value;
   }
   elsif ( $name eq 'Minimum_Width' ) {
      $minimum_width = $value;
   }
}

$format = "\%0$minimum_width"; $format .= "d";

open ( InFile , $counter_file ) or die ( "Can't open $counter_file:$ ! " );

@pairs = <InFile>;

$counter_value = -1;
$index = -1;
foreach $pair ( @pairs ) {
   ( $left , $right ) = split ( /=/ , $pair );
   chomp ( $right );
   $index++;
   if ( $left eq $counter_name ) {
      $right++;
      $counter_value = $right;
   }
   $name[$index] = $left; $value[$index] = $right;
}

close ( InFile );

if ( $counter_value ne '-1' ) {       ### Write counter values back to file ###
   open ( OutFile , ">$counter_file" ) or die ( "Can't open $counter_file:$ ! " );
   for ( $index=0 ; $index<@name ; $index++ ) {
      if ( $name[$index] ne '' && $value[$index] ne '') {
         print OutFile "$name[$index]=$value[$index]\n";
      }
   }
   close ( OutFile );
}

print "Content-Type: text/html\n\n";               ### Output counter value ###
print "<table><tr><td bgcolor=\"Black\"><font face=\"Arial\" Color=\"White\" size=\"3\">";
printf ("<b>$format</b>", $counter_value);
print "</font></td></tr></table>\n";

exit;

